<?php
/*********************************************************

* DO NOT REMOVE *

Project: PHP Photo Gallery 1.0
Url: http://phpweby.com/software/gallery
Copyright: (C) 2009 Blagoj Janevski - bl@blagoj.com
Project Manager: Blagoj Janevski

For help, comments, feedback, discussion ... please join our
Webmaster forums - http://forums.phpweby.com

License------------------------------------------------:
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
End License----------------------------------------------

Link to http://phpweby.com can not be removed from the software pages
without permission of Blagoj Janevski <bl@blagoj.com>.
It is the only requirement for using this software.

*********************************************************/

require_once('phpwatermark/phpWatermark.inc.php');

class watermark_weby extends watermark
{

	function ttfApplyWatermark($text='', $fontsize=16, $angle=0, $font='font.ttf')
	{
		if($fontsize=='' || $fontsize<1)
		$fontsize=14;
		
		$ttfbox = imagettfbbox($fontsize, $angle, $font, $text);

		$ttfbox[0]=abs($ttfbox[0]);
		$ttfbox[1]=abs($ttfbox[1]);
		$ttfbox[2]=abs($ttfbox[2]);
		$ttfbox[3]=abs($ttfbox[3]);
		$ttfbox[4]=abs($ttfbox[4]);
		$ttfbox[5]=abs($ttfbox[5]);
		$ttfbox[6]=abs($ttfbox[6]);
		$ttfbox[7]=abs($ttfbox[7]);

		$xmax =max($ttfbox[0],$ttfbox[2],$ttfbox[4],$ttfbox[6]);
		$ymax =max($ttfbox[1],$ttfbox[3],$ttfbox[5],$ttfbox[7]);

		$xmin =min($ttfbox[0],$ttfbox[2],$ttfbox[4],$ttfbox[6]);
		$ymin =min($ttfbox[1],$ttfbox[3],$ttfbox[5],$ttfbox[7]);

		unset($ttfbox);

		$ttfwidth=abs($xmax - $xmin);
		$ttfheight=abs($ymax - $ymin);

		$this->sizes['box_w']=$ttfwidth;
		$this->sizes['box_h']=$ttfheight;
		$this->sizes['spacer_h']=$fontsize;
		$this->sizes['spacer_w']=$fontsize;
		

		if(substr($this->position,0,1)=='T')
		$this->sizes['spacer_h']+=16;
		
		$this->_getOffsets();

		$textcolor = imagecolorallocate($this->image, $this->fixedColor['r'],$this->fixedColor['g'], $this->fixedColor['b']);

		imagettftext($this->image, $fontsize, $angle, $this->offset_x+10, $this->offset_y + $ttfheight + intval($fontsize/3.2), $textcolor, $font , $text);

		$this->marked_image=$this->image;
		$this->imageCreated=true;

	}
	
	function destruct()
	{
		@imagedestroy($this->image);
		@imagedestroy($this->marked_image);
	}
	
}

function watermarkphoto($photo,$opt)
{

	$wm = new watermark_weby($photo);

	$wm->setPosition($opt['position']);

	if($opt['type']=='photo')
	{
		if(@file_exists($opt['photo']))
		{
			$wm->addWatermark($opt['photo'], 'IMAGE');

		}
		else
		{
			$wm->destruct();
			return 0;
		}
	}
	else
	{
		$wm->setFixedColor($opt['color']);

		if($opt['font']==1)
		{
			if($opt['text']!='')
			{
				$wm->ttfApplyWatermark($opt['text'],$opt['font_size'],0,ABSPATH . '/jadro/libs/phpwatermark/font/font.ttf');

			}
			else
			{
				$wm->destruct();
				return 0;
			}

		}
		else
		{
			if($opt['text']!='')
			{

				$wm->addWatermark($opt['text'], 'TEXT');


			}
			else
			{
				$wm->destruct();
				return 0;
			}

		}

	}


	$mime=getmimetype($opt['destination']);

	if($mime=='jpg')
	$mime='jpeg';

	$func='image'.$mime;

	if(function_exists($func))
	@$func($wm->getMarkedImage(),$opt['destination']);

	$wm->destruct();
	
	return 1;
}

function watermarkphoto_s($photopath)
{
	definevars("where id='WATERMARK_WITH' or id='WATERMARK_TEXT' or id='WATERMARK_PHOTO' or id='WATERMARK_FONT' or id='WATERMARK_TEXT_COLOR' or id='WATERMARK_POSITION' or id='WATERMARK_FONT_SIZE'");
	$opt=array();
	$opt['destination']=$photopath;
	$opt['photo']=WATERMARK_PHOTO;
	$opt['text']=WATERMARK_TEXT;
	$opt['font']=WATERMARK_FONT;
	$opt['type']=WATERMARK_WITH;
	$opt['color']=WATERMARK_TEXT_COLOR;
	$opt['position']=WATERMARK_POSITION;
	$opt['font_size']=WATERMARK_FONT_SIZE;
	watermarkphoto($photopath,$opt);
}

